<div>
  <mat-form-field appearance='outline'>
    <mat-label>Level</mat-label> 
    <input matInput formControlName='level'/>
    <mat-error *ngIf="heroesForm.invalid">Level is required</mat-error>
  </mat-form-field>
  
  <mat-form-field appearance='outline'>
    <mat-label>Experience</mat-label> 
    <input matInput  formControlName='experience'/>
    <mat-error *ngIf="heroesForm.invalid">Experience is required</mat-error>
  </mat-form-field>
  
  <mat-form-field appearance='outline'>
    <mat-label>Rank</mat-label> 
    <input matInput  formControlName='rank'/>
    <mat-error *ngIf="heroesForm.invalid">Rank is required</mat-error>
  </mat-form-field>
  <br />

  <div formArrayName="allies">
    <div *ngFor="let ally of allyArr.controls; let i = index" [formGroupName]="i">
      <mat-form-field appearance='outline'>
        <mat-label>Ally</mat-label> 
        <input matInput  formControlName='allyname'/>
        <mat-error *ngIf="heroesForm.invalid">Ally Name is required</mat-error>
      </mat-form-field>

      <button mat-raised-button type="button" (click)='removeAt(i)'>X</button>
    </div>
  </div>

  <button mat-raised-button type="button" (click)='addAlly()'>Add Ally</button>
</div>



